#!/usr/bin/tclsh
set fp [open "/etc/sysconfig/iptables" "r"]
set tables [read $fp]
close $fp
set tl [split $tables "\n" ]
global current_table current_chain counter_chains warnings_tags
set current_table ""
set current_chain ""
set counter_chains 1
set warnings_tags [list "-m limit" "-m account" "-m addrtype" "-m ah" "-m childlevel" "--comment" "--condition" "--connbytes" "--connlimit" ]

set BASE "/etc/dwall-alt/expert/v1/"
eval exec rm -rf $BASE/*

foreach rec $tl {
  set x [string index "$rec" 0]
  switch -exact -- $x {
	"*" { 
	      set current_table [string range "$rec" 1 end]
	      catch {exec mkdir $BASE/$current_table}
	      set counter_chains 1
	      cd $BASE/$current_table
	}
        '#' { 
	  
	}
	"C" {
	}
	":" {
		set chain_name [string range [lindex [split $rec " "] 0] 1 end]
		set current_chain $chain_name
		catch {exec mkdir $BASE/$current_table/$chain_name}
		cd $BASE/$current_table/$chain_name
		set policy [lindex [split $rec " "] 1]
		set polfile [open ".policy" "w"]
		puts $polfile $policy 
		close $polfile
		set counter_chains 0
	}
	"-"  {
	   # the rule should be at its chain, which is directed by -A here
           set xrl [split $rec " " ]
	   set whereto [lindex $xrl 1]
	   cd $BASE/$current_table/$whereto
	   set normal_rule 1
	   foreach el $warnings_tags {
	     if { [string first $el $rec] != -1 } {
	     set normal_rule 0
	     puts "Warning: rule $rec not implemented; will be ignored"
	     }
	   }
	   if { $normal_rule ==  1 } {
               set rulefile [open $counter_chains "w"]
	       puts $rulefile $rec
	       close $rulefile
	       incr counter_chains
	   }
        }	
   }

}
